/**********************************************************************************************************************
 * DISCLAIMER
 * This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products. No
 * other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
 * applicable laws, including copyright laws.
 * THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING
 * THIS SOFTWARE, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT. ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED. TO THE MAXIMUM
 * EXTENT PERMITTED NOT PROHIBITED BY LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES
 * SHALL BE LIABLE FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO
 * THIS SOFTWARE, EVEN IF RENESAS OR ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 * Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability of
 * this software. By using this software, you agree to the additional terms and conditions found by accessing the
 * following link:
 * http://www.renesas.com/disclaimer
 *
 * Copyright (C) 2020 Renesas Electronics Corporation. All rights reserved.
 *********************************************************************************************************************/
/************************************************************************
*
* Device     : RX/RX600/RX63N,RX631
*
* File Name  : hwsetup.c
*
* Abstract   : Hardware Setup file.
*
* History    : 0.10  (2011-02-21)  [Hardware Manual Revision : 0.01]
*
* NOTE       : THIS IS A TYPICAL EXAMPLE.
*
* Copyright (C) 2011 Renesas Electronics Corporation.
* and Renesas Solutions Corp.
*
************************************************************************/

/**
 * @file  hwsetup.c
 * @brief n[hEFAZbgAbv
 *
 * {\tgEFA̒쌠͍쐬ł()kldqL̂ƂA
 * ()kldq́Aȉ (1)`(3) ̏𖞂ꍇɌA
 * {\tgEFAi{\tgEFAς̂܂ށBȉj
 * gpEEρEĔzziȉApƌĂԁj邱Ƃ𖳏ŋB
 *
 * (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́AL̒
 *	   \A̗pÂ܂܂̌`Ń\[XR[hɊ܂܂
 *	   邱ƁB
 * (2) {\tgEFÄꕔ܂͑SĂ𖳒fœ]ڂ邱Ƃ֎~
 *	   ƂBGȂǂ֏ЉE^̏ꍇ()kldqɘA肢܂B
 * (3) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹Q
 *	   A()kldq͈؂̐ӔC𕉂Ȃ̂ƂB
 *
 * Copyright (C) Hokuto denshi Co,Ltd. 2013-2021
 */

#include <machine.h>
#include "iodefine.h"
#include "board.h"

static void ClockInit( void );
static void SdramInit( void );

#ifdef __cplusplus
extern "C" {
#endif
extern void HardwareSetup(void);
#ifdef __cplusplus
}
#endif

void HardwareSetup(void)
{

	SYSTEM.PRCR.WORD = 0xA50B;			// veNgWX^
	
	ClockInit();
	
#ifdef SDRAM
	SdramInit();
#endif
	
	SYSTEM.PRCR.WORD = 0xA500;			// veNgWX^ݒ
}

/** NbNݒ
 * @param void
 * @retval void
 */
static void ClockInit( void )
{
	volatile unsigned int i;

	// ̓NbN12MHz
	SYSTEM.PLLCR.BIT.PLIDIV	= 0x00;		// PLL͕(1)    = 12MHz
	SYSTEM.PLLCR.BIT.STC	= 0x0F;		// PLLg{(16{) = 12 * 16 = 192
	SYSTEM.SCKCR2.BIT.UCK	= 0x03;		// USBNbN(4) = 192/4 = 48MHz
	SYSTEM.SCKCR2.BIT.IEBCK	= 0x03;		// IECLK = 192/8 = 24MHz

	SYSTEM.MOSCCR.BYTE = 0x00;			// CNbNU
	SYSTEM.PLLCR2.BYTE = 0x00;			// PLLH𓮍Jn

	for(i = 0;i< 0x14A;i++)				// wait over 11ms
	{
		;
	}

	SYSTEM.SCKCR.LONG = 0x21021211;		// FCK:FlashNbN			= 192 / 4 = 48MHz
										// ICK:VXeNbN			= 192 / 2 = 96MHz
										// BCK:OoXNbN			= 192 / 4 = 48MHz
										// PCKA:ӃW[NbNA	= 192 / 2 = 96MHz
										// PCKB:ӃW[NbNB	= 192 / 4 = 48MHz

	SYSTEM.SCKCR3.WORD = 0x0400;		// PLLI
}

/** SDRAMݒ
 * @param void
 * @retval void
 */

static void SdramInit( void )
{
	/* [hݒ */
	SYSTEM.SYSCR0.WORD = 0x5A03;			//ROMLAOoXL

	PORT6.PDR.BIT.B0 = 1;					//OSDRAMʂƂ邽ߋL
	PORT6.PODR.BIT.B0 = 0;					//OSDRAMɂENABLEMLLOWɂĂȂƓ삵Ȃ

	/* SDRAM|[gݒ */
	SYSTEM.SCKCR.BIT.PSTOP0		= 1;		// ύXJn
	MPC.PFAOE0.BYTE				= 0xFF;		// A8`A15AhXo͋
	MPC.PFBCR0.BIT.ADRLE		= 1;		// PA0`PA7OAhXoXA0`A7ƂĐݒ
	MPC.PFBCR0.BIT.DHE			= 1;		// PE0`PE7Of[^oXD8`D15ƂĐݒ
	MPC.PFBCR1.BIT.SDCLKE		= 1;		// SDCLKo͗L
	MPC.PFBCR1.BIT.MDSDE		= 1;		// CKEASDCS#ARAS#ACAS#AWE#ADQM0o͗L
	MPC.PFBCR1.BIT.DQM1E		= 1;		// DQM1o͗L
	SYSTEM.SCKCR.BIT.PSTOP0 	= 0 ;		// ύXI

	/* V[PX */
	BSC.SDIR.BIT.PRC			= 0;		// v`[WTCNݒ
	BSC.SDIR.BIT.ARFC			= 2;		// I[gtbV
	BSC.SDIR.BIT.ARFI			= 1;		// I[gtbVԊu
	BSC.SDICR.BIT.INIRQ			= 1;		// V[PXJn

	/* SDRAMCݒ */
	while( BSC.SDSR.BYTE != 0x00 );
	BSC.SDAMOD.BIT.BE			= 0 ;		// AANZX֎~
	BSC.SDCCR.BIT.BSIZE			= 0;		// 16rbgoX
	BSC.SDMOD.BIT.MR			= 0x0030;	// [hWX^R}hs
	BSC.SDTR.BIT.RAS			= 3;		// EANeBuԐݒ
	BSC.SDTR.BIT.RCD			= 2;		// EJCeVݒ
	BSC.SDTR.BIT.RP				= 1;		// Ev`[WԐݒ
	BSC.SDTR.BIT.WR				= 1;		// CgJoԐݒ
	BSC.SDTR.BIT.CL				= 3;		// SDRAMCJCeVݒ
	BSC.SDADR.BIT.MXC			= 1;		// AhX}`vNXI(9rbgVtg)

	/* I[gtbVJn */
	BSC.SDRFCR.BIT.RFC			= 375;		// I[gtbVvԊuݒ
	BSC.SDRFCR.BIT.REFW			= 2;		// I[gtbVTCN^ZttbVTCNݒ
	BSC.SDRFEN.BIT.RFEN			= 1;		// I[gtbVL

	/* ANZX */
	BSC.SDCCR.BIT.EXENB			= 1;		// 싖
}
